# Документация Limb3
## Введение

* [Если вы новичок в Limb3...](./ru/for_beginners.md) (основные моменты, советы, где искать описания и примеры).
* [Часто задаваемые вопросы (FAQ)](./ru/faq.md)
* [Где и как скачать Limb3?](./ru/how_to_download.md)
* [Разделение Limb3 на пакеты. Что такое пакеты в Limb3?](./ru/packages_architecture.md)
* [Полный список пакетов Limb3 с описаниями](./ru/packages.md)
* [Как запустить тесты на пакеты Limb3](./ru/how_to_run_tests.md)
* [Конфигурационные файлы в Limb3](./ru/setup_files.md)
* [Конфигурационные переменные используемые в Limb3](./ru/constants.md)
* [Стандарты кодирования Limb3](./ru/coding_standards.md)
* [Работа с репозиторием Limb3](./ru/svn.md)
* [Инструкция пользователя](./ru/index.md) (пишется в данный момент)

## Основные пакеты
[Полный список пакетов Limb3 с описаниями](./ru/packages.md)

[Утилита limb.php](../taskman/docs/ru/taskman/limb.php.md)

  * [Пакет CORE](../core/docs/ru/core.md)
  * [Пакет TOOLKIT](../toolkit/docs/ru/toolkit.md)
  * [Пакет DBAL](../dbal/docs/ru/dbal.md)
    * [Использование классов из подсистем Query и Criteria](../dbal/docs/ru/dbal/intro_to_query_and_criteria.md)
  * [Пакет ACTIVE_RECORD](../active_record/docs/ru/active_record.md)
    * [Создание, сохранение, загрузка и удаление объектов](../active_record/docs/ru/active_record/crud.md)
    * [Поиск и сортировка объектов. find()-методы lmbActiveRecord](../active_record/docs/ru/active_record/find.md)
    * [Отношение один-к-одному](../active_record/docs/ru/active_record/one_to_one.md)
    * [Отношение один-ко-многим](../active_record/docs/ru/active_record/one_to_many.md)
    * [Отношение много-ко-многим](../active_record/docs/ru/active_record/many_to_many.md)
  * [Пакет MACRO](../macro/docs/ru/macro.md)
    * [Словарь MACRO-тегов](../macro/docs/ru/macro/tags.md)
    * [Словарь MACRO-фильтров](../macro/docs/ru/macro/filters.md)
  * [Пакет WEB_APP](../web_app/docs/ru/web_app.md)
    * [Пример установки каркасного приложения для работы с WEB_APP пакетом](../web_app/docs/ru/web_app/app_installation.md)
  * [Пакет TESTS_RUNNER](../tests_runner/docs/ru/tests_runner.md)
    * [limb_unit — консольный инструмент для выполнения SimpleTest тестов](../tests_runner/docs/ru/tests_runner/limb_unit.md)

## Подробные примеры реализации готовых решений с помощью Limb3

* [Как создать простейшее CRUD-приложение](./ru/tutorials/basic.md)
* [Как создать электронный магазин при помощи Limb3](./ru/tutorials/shop.md)
* [Как интегрировать Zend_Search с Limb3](./ru/tutorials/zend_search.md)

[Недостающие документы](./new_files.md)
