# Пакет WEB_APP
WEB_APP пакет является как бы собирающим пакетом для многих низкоуровневых Limb3 пакетов, таких как CORE, DBAL, VIEW, NET, TOOLKIT и др. При помощи WEB_APP пакета создаются web-приложения на базе Limb3, в которых применяется паттерн MVC (Model-View-Controller). Некоторые компоненты, например, контроллер, может вам напомнить Rails, если вы конечно знакомы с этим фреймворком.

Данное описание WEB_APP пакета расчитано на достаточно опытных разработчиков, которые знакомы с базовыми паттернами проектирования, такими как MVC, Singleton, Factory, Decorator, FilterChain и другими. Также мы рассчитываем, что вы ознакомились с [примером реализации электронного магазина при помощи Limb3](../../../docs/ru/tutorials/shop.md), или же вы имеете опыт разработки с применением других MVC-фреймворков.

## Скелет приложения
[Создание веб-приложения из скелета](./web_app/app_installation.md)

## Архитектура

* **Общая информация**
  * [Общая организация пакета WEB_APP. Наиболее значимые компоненты](./web_app/main_components.md)
* **Организация контроллера (Controller)**
  * [Ключевые понятия контроллера](./web_app/controller.md)
  * [Схема типичного Limb3 web-приложения, выполненого при помощи пакета WEB_APP](./web_app/pplication_workflow.md)
  * [Использование цепочки фильтров для организации Front-Controller](./web_app/filter_chain.md)
  * [Разбор запроса](./web_app/request_dispatching.md)
  * [Класс lmbController](./web_app/lmb_controller.md)
* **Организация отображения (View)**
  * [Общая схема организация отображения (View). Pull view Vs Push view](./web_app/view.md)
  * [Шаблонизатор WACT. Его роль в Limb3. Возможность использования других шаблонизаторов, кроме WACT](./web_app/template_engines.md)
  * [Обзор предустановленных средств для отображения](./web_app/predefined_views.md)
* **Прочие подсистемы**
  * [lmbWebAppTools](./web_app/lmb_web_app_tools.md) — инструментарий (tools) пакета WEB_APP
  * [Валидация данных](./web_app/validation.md)
  * [Передача произвольных сообщений пользователям. Flashbox](./web_app/flash_box.md)
  * [Работа с сессией](./web_app/session.md)
  * [Работа с cookie](./web_app/cookie.md)

## Некоторые моменты использования пакета WEB_APP

* **Работа с формами**
  * [Работа с формами. Шаблоны форм, отображение ошибок валидации](./web_app/form_processing.md)
  * [Многостраничные формы (визарды)](./web_app/wizard.md)
  * [Вывод и заполнение матриц из checkbox-ов](./web_app/checkbox_matrix.md)
* Мультиязычность и интернационализация
  * [Советы по созданию мультиязычных сайтов](./web_app/multilanguage.md)
